##########################################################################################
# Config Flags
##########################################################################################

# Set to true if you do *NOT* want Magisk to mount
# any files for you. Most modules would NOT want
# to set this flag to true
SKIPMOUNT=false

# Set to true if you need to load system.prop
PROPFILE=true

# Set to true if you need post-fs-data script
POSTFSDATA=true

# Set to true if you need late_start service script
LATESTARTSERVICE=true

##########################################################################################
# Replace list
##########################################################################################

# List all directories you want to directly replace in the system
# Check the documentations for more info why you would need this

# Construct your list in the following format
# This is an example
# REPLACE_EXAMPLE="
# /system/app/Youtube
# /system/priv-app/SystemUI
# /system/priv-app/Settings
# /system/framework
# "

# Construct your own list here
REPLACE=""

##########################################################################################
#
# Function Callbacks
#
# The following functions will be called by the installation framework.
# You do not have the ability to modify update-binary, the only way you can customize
# installation is through implementing these functions.
#
# When running your callbacks, the installation framework will make sure the Magisk
# internal busybox path is *PREPENDED* to PATH, so all common commands shall exist.
# Also, it will make sure /data, /system, and /vendor is properly mounted.
#
##########################################################################################
##########################################################################################
#
# The installation framework will export some variables and functions.
# You should use these variables and functions for installation.
#
# ! DO NOT use any Magisk internal paths as those are NOT public API.
# ! DO NOT use other functions in util_functions.sh as they are NOT public API.
# ! Non public APIs are not guranteed to maintain compatibility between releases.
#
# Available variables:
#
# MAGISK_VER (string): the version string of current installed Magisk
# MAGISK_VER_CODE (int): the version code of current installed Magisk
# BOOTMODE (bool): true if the module is currently installing in Magisk Manager
# MODPATH (path): the path where your module files should be installed
# TMPDIR (path): a place where you can temporarily store files
# ZIPFILE (path): your module's installation zip
# ARCH (string): the architecture of the device. Value is either arm, arm64, x86, or x64
# IS64BIT (bool): true if $ARCH is either arm64 or x64
# API (int): the API level (Android version) of the device
#
# Availible functions:
#
# ui_print <msg>
#     print <msg> to console
#     Avoid using 'echo' as it will not display in custom recovery's console
#
# abort <msg>
#     print error message <msg> to console and terminate installation
#     Avoid using 'exit' as it will skip the termination cleanup steps
#
# set_perm <target> <owner> <group> <permission> [context]
#     if [context] is empty, it will default to "u:object_r:system_file:s0"
#     this function is a shorthand for the following commands
#       chown owner.group target
#       chmod permission target
#       chcon context target
#
# set_perm_recursive <directory> <owner> <group> <dirpermission> <filepermission> [context]
#     if [context] is empty, it will default to "u:object_r:system_file:s0"
#     for all files in <directory>, it will call:
#       set_perm file owner group filepermission context
#     for all directories in <directory> (including itself), it will call:
#       set_perm dir owner group dirpermission context
#
##########################################################################################x

# Set what you want to display when installing your module


print_modname() {
    return
}

# Copy/extract your module files into $MODPATH in on_install.
on_install() {



    unzip -o "$ZIPFILE" -x 'META-INF/*' -d $MODPATH >/dev/null
    set_perm_recursive "$MODPATH" 0 0 0755 0644
    
. $MODPATH/script/quanj.sh

abort() {
    echo "$1"
    echo "安装失败."
    exit 1
}

VolumeKey() {
ui_print "- 监听音量键 按[+]选择"是" 按[-]选择"否""
while true; do sleep 0.5
keyInfo=$(getevent -qlc 1 | grep KEY_VOLUME)
if [ "$keyInfo" == "" ]; then
continue
else
UpKey=$(echo $keyInfo | grep KEY_VOLUMEUP)
[ "$UpKey" != "" ] && return 0 || return 1
break
fi
done
}

peiz1="$MODPATH/files/peiz"
peiz="$MODPATH/files"
mkdir $peiz
touch $peiz1
echo $(getprop ro.board.platform) > $peiz1
#判断处理器
if [ ! -f $MODPATH/config/a.$(getprop ro.board.platform).sh ]; then
echo $(getprop ro.board.platform) > $peiz1
 if [ ! -f $MODPATH/config/b.$(getprop ro.board.platform).sh ]; then
  echo "没有该处理器的a.$(getprop ro.board.platform).sh配置文件或没有该处理器的b.$(getprop ro.board.platform).sh配置文件."
echo "

"
  echo "使用通用配置all"
  echo "all" > $peiz1
 fi
fi


echo "

"
echo "---------------------------"
#判断模式
if cat /sys/devices/system/cpu/cpufreq/policy*/scaling_available_governors | grep -q "walt"; then
echo "a方案walt可以使用"
else
if cat /sys/devices/system/cpu/cpufreq/policy*/scaling_available_governors | grep -q "schedutil"; then
echo "只有b方案schedutil可用"
else
echo "无walt和schedutil调速器"
fi
fi

echo "

"
echo "---------------------------"
#说明
echo "【使用必看！】"
echo "①请使用官核，其他第三方核，经测试体验并不友好"
echo "例如小米pad6spro会导致卡顿，功耗增加"
echo ""
echo "②asoul建议设置mode=2"
echo ""
echo "③系统适配问题，经测试和反馈，目前能在澎湃MIUI，Flyme，coloros，上使用，刷移植的不确定，红魔没具体看来，三星系统适配不了（建议还是用官调吧，或者scene调度）"
echo ""
echo "等待10秒"
sleep 10

echo "

"
echo "---------------------------"
echo "阅读了使用必看是否继续安装（三星系统不建议安装）"

if VolumeKey; then
ui_print "- 你选择是"
echo "继续安装中..."
else
ui_print "- 你选择否"
  abort "用户选择退出安装"
fi


#创建模式切换文件
filePath="$mokml/cur_powermode.txt"
dir="$mokml"
if [ ! -d "$dir" ];then
mkdir $dir
echo "创建文件夹成功"
else
echo "文件夹已经存在"
fi
if [ ! -f "$filePath" ];then
touch $filePath
echo "未执行模式切换(请重启手机)" > $filePath
echo "文件创建完成"
else
echo "文件已经存在"
fi
if [ -f $mokml/动态模式切换.conf ]; then
sleep 1
else
cp -af $MODPATH/$mingc/* $mokml/
cp -af $MODPATH/README.md $mokml/说明.md
rm -f $mokml/*.sh
fi

echo "

"

echo "---------------------------"


echo "是否启用调度辅助模式（可以配合其他调度使用scene调度除外）"

if VolumeKey; then
ui_print "- 你选择是"

else
ui_print "- 你选择否"
rm -f /$MODPATH/script/fz
fi

echo "

"



echo "---------------------------"

#停用coloros和MIUI部分云控和锁帧
echo "是否屏蔽coloros云控（非coloros请无视）"

if VolumeKey; then
ui_print "- 你选择是"
. /$MODPATH/script/coloros.sh
else
ui_print "- 你选择否"
rm -f /$MODPATH/script/coloros.sh
fi

echo "

"
echo "是否屏蔽MIUI澎湃云控（非MIUI澎湃请无视）"

if VolumeKey; then
ui_print "- 你选择是"
. /$MODPATH/script/miui.sh
else
ui_print "- 你选择否"
rm -f /$MODPATH/script/miui.sh
fi

echo "

"
echo "---------------------------"
#安装清楚指定App数据

echo "是否选择清除miui云控APP数据（非miui请无视）"

if VolumeKey; then
ui_print "- 你选择是"
#joyose
pm clear com.xiaomi.joyose
#网络电池与性能
pm clear com.miui.powerkeeper
#analytics
pm clear com.miui.analytics
#安全服务（游戏助手）
pm clear com.miui.securitycenter


else
ui_print "- 你选择否"

fi

echo "

"

echo "是否选择清除coloros云控APP数据（非coloros请无视）"

if VolumeKey; then
ui_print "- 你选择是"
#游戏助手
pm clear com.oplus.games
#增强服务
pm clear com.oplus.cosa
#电池
pm clear com.oplus.battery

else
ui_print "- 你选择否"

fi
    
fullApkPath=$(ls "$MODPATH"/qingtd*.apk)
apkPath=$TMPDIR/qingtd.apk
mv -f "$fullApkPath" "$apkPath"
chmod 666 "$apkPath"

echo "- 轻调度APP 正在安装..."
output=$(pm install -r -f "$apkPath" 2>&1)
if [ "$output" == "Success" ]; then
    echo "- 轻调度APP 安装成功"
    rm -rf "$apkPath"
else
    echo "- 轻调度 安装失败, 原因: [$output] 尝试卸载再安装..."
    pm uninstall com.qingtd.miao
    sleep 1
    output=$(pm install -r -f "$apkPath" 2>&1)
    if [ "$output" == "Success" ]; then
        echo "- 轻调度 安装成功"
        rm -rf "$apkPath"
    else
        apkPathSdcard="/sdcard/qingtd_${module_version}.apk"
        cp -f "$apkPath" "$apkPathSdcard"
        echo "!!! *********************** !!!"
        echo "  轻调度APP 依旧安装失败, 原因: [$output]"
        echo "  请手动安装 [ $apkPathSdcard ]"
        echo "  如果是降级安装, 请手动卸载轻调度APP, 然后再次安装。"
        echo "!!! *********************** !!!"
    fi
fi

    
    [ "$?" != "0" ] && abort
    



}

# Only some special files require specific permissions
# This function will be called after on_install is done
# The default permissions should be good enough for most cases
set_permissions() {
    return
}

# You can add more functions to assist your custom script code
