wj_zr() {
    local value="$1"
    local file="$2"
if [ -f $2 ]; then
	chmod 777 $file
	echo $value > $file
	chmod 444 $file
fi
}

mian_loads_freq() {
	for file in /sys/devices/system/cpu/cpufreq/policy[0-9]
	do
	      #获取CPU最大频率
	       sz=$(cat $file/cpuinfo_max_freq)       
           
           sz1=$(($sz*$1/100))
           sz2=$(($sz*$2/100))
           #修改调速器
           dz=$file/scaling_governor        
           wj_zr "schedutil" $dz
           

	      #修改rtg_boost_freq
           dz=$file/schedutil/rtg_boost_freq
                     
           wj_zr $sz1 $dz

           #修改hispeed_freq
           dz=$file/schedutil/hispeed_freq
                     
           wj_zr $sz2 $dz
           
           #修改hispeed_load为90
           dz=$file/schedutil/hispeed_load
                     
           wj_zr $3 $dz
           
           #修改pl
           dz=$file/schedutil/pl
                     
           wj_zr $4 $dz

	done
}

sched_load_boost() {
	for file in /sys/devices/system/cpu/cpu[0-9]
	do

	      #修改rtg_boost_freq
           dz=$file/sched_load_boost
                     
           wj_zr $1 $dz


	done
	
	for file in /sys/devices/system/cpu/cpufreq/policy[0-9]
	do
           #修改boost
           dz=$file/schedutil/boost
                     
           wj_zr $1 $dz
    done
}




schedutil_up_rate_limit_us() {
	for file in /sys/devices/system/cpu/cpufreq/policy[0-9]
	do
	      #修改up_rate_limit_us
           dz=$file/schedutil/up_rate_limit_us
                     
           wj_zr $1 $dz
           
	      #修改down_rate_limit_us
           dz=$file/schedutil/down_rate_limit_us
                     
           wj_zr $2 $dz
           
           
	      #获取CPU最大频率
	       sz=$(cat $file/cpuinfo_max_freq)       
           
           sz1=$(($sz*$3/100))
           sz2=$(($sz*$4/100))
           
           
           #修改target_loads
           dz=$file/schedutil/target_loads
                     
           if [ $(cat $mosdz/pand) -eq 1 ]; then
               wj_zr "80 $sz1:85 $sz2:95" "$dz"
               else
               
               sz1=$(($sz1*10/8))
               sz2=$(($sz2*10/8))
               wj_zr "0 $sz1:-14 $sz2:-20" "$dz"
           fi
           
           
	      #修改fast_ramp_up
           dz=$file/schedutil/fast_ramp_up

           wj_zr $5 $dz
           
	      #修改fast_ramp_down
           dz=$file/schedutil/fast_ramp_down

           wj_zr $6 $dz
           
           

	done
}




json_cpu_max_min() {
	#cpumax和min
	for file in /sys/devices/system/cpu/cpufreq/policy[0-9]
	do
	       sz=$(cat $file/cpuinfo_max_freq)
           #采用1/100
           sz1=$(($sz*$1/100))
           sz2=$(($sz*$2/100))

           dz=$file/scaling_max_freq           
           wj_zr $sz1 $dz
           
           dz=$file/scaling_min_freq
           wj_zr $sz2 $dz
	done
}

cpu_DDR() {
	ddrdz=/sys/devices/system/cpu/bus_dcvs/DDR
	
	sz=0
	for line in `cat  $ddrdz/available_frequencies`
     do

         if [ $line -gt $sz ]; then
                sz=$line
         fi
    done
	sz1=$(($sz*$1/100))
	sz2=$(($sz*$2/100))
	for file in $ddrdz/*/max_freq
	do
           wj_zr $sz1 $dz
	done
	for file in $ddrdz/*/min_freq
	do
           wj_zr $sz2 $dz
	done
	
	
for file in /sys/class/devfreq/soc:qcom,cpu*-cpu-ddr-latfloor
do

	sz=0
	for line in `cat  $file/available_frequencies`
     do

         if [ $line -gt $sz ]; then
                sz=$line
         fi
    done
	sz1=$(($sz*$1/100))
	sz2=$(($sz*$2/100))
	for line in $file/max_freq
	do
           wj_zr $sz1 $dz
	done
	for line in $file/min_freq
	do
           wj_zr $sz2 $dz
	done



done
}


GPUmin() {
#修改GPU最大值为最大
       sz=0
	       for line in $(cat /sys/class/kgsl/kgsl-3d0/devfreq/available_frequencies)
           do
                if [ $sz -eq 0 ]; then
                sz=$line
                fi
                if [ $line -gt $sz ]; then
                sz=$line
                fi
           done

           dz=/sys/class/kgsl/kgsl-3d0/devfreq/max_freq
           wj_zr $sz $dz
#修改GPU最小值为最小
       sz=0
	       for line in $(cat /sys/class/kgsl/kgsl-3d0/devfreq/available_frequencies)
           do
                if [ $sz -eq 0 ]; then
                sz=$line
                fi
                if [ $line -lt $sz ]; then
                sz=$line
                fi
           done

           dz=/sys/class/kgsl/kgsl-3d0/devfreq/min_freq
           wj_zr $sz $dz
#修改GPU功耗模型最小值为最小       
       sz=-1
	       for line in $(cat /sys/class/kgsl/kgsl-3d0/devfreq/available_frequencies)
           do
                sz=$(($sz+1))
           done       
           dz=/sys/class/kgsl/kgsl-3d0/default_pwrlevel
           wj_zr $sz $dz
	       
           dz=/sys/class/kgsl/kgsl-3d0/idle_timer
           wj_zr "80" $dz
	       
}

gpu_mx_max_min() {
       sz=-1
	       for line in $(cat /sys/class/kgsl/kgsl-3d0/devfreq/available_frequencies)
           do
                sz=$(($sz+1))
           done
           	sz1=$(($sz*(100-$1)/100))
           	sz2=$(($sz*(100-$2)/100))
           
           dz=/sys/class/kgsl/kgsl-3d0/max_pwrlevel
           wj_zr $sz1 $dz
           dz=/sys/class/kgsl/kgsl-3d0/min_pwrlevel
           wj_zr $sz2 $dz
}
